import { ApiProperty } from '@nestjs/swagger';
import { IsEmail, IsNotEmpty, IsString } from 'class-validator';

export class PendingStructureDto {
  @IsNotEmpty()
  @IsEmail()
  @ApiProperty({ type: String })
  readonly userEmail: string;

  @IsNotEmpty()
  @IsString()
  @ApiProperty({ type: String })
  readonly structureId: string;

  @IsNotEmpty()
  @IsString()
  @ApiProperty({ type: String })
  structureName: string;
}
