import { Test, TestingModule } from '@nestjs/testing';
import { AppController } from './app.controller';
describe('AppController', () => {
  let app: TestingModule;

  beforeAll(async () => {
    app = await Test.createTestingModule({
      controllers: [AppController],
    }).compile();
  });

  describe('healthcheck', () => {
    it('should return "Hello World!"', async () => {
      const appController = app.get<AppController>(AppController);
      const result = { status: 'API Online', uptime: 1 };
      jest.spyOn(appController, 'healthcheck').mockImplementation(async (): Promise<{ status; uptime }> => result);
      expect(await appController.healthcheck()).toBe(result);
    });
  });
});
