import { Body, Controller, Get, Post } from '@nestjs/common';
import { CategoriesAccompagnementService } from '../services/categories-accompagnement.service';
import { CreateCategoriesAccompagnement } from '../dto/create-categoriesAccompagnement.dto';
import { CategoriesAccompagnement } from '../schemas/categoriesAccompagnement.schema';

@Controller('categories/categoriesAccompagnement')
export class CategoriesAccompagnementController {
  constructor(private readonly categoriesAccompagnementService: CategoriesAccompagnementService) {}

  @Post()
  public async create(@Body() createStructureDto: CreateCategoriesAccompagnement) {
    await this.categoriesAccompagnementService.create(createStructureDto);
  }

  @Get()
  public async findAll(): Promise<CategoriesAccompagnement[]> {
    return this.categoriesAccompagnementService.findAll();
  }
}
