import { Body, Controller, Get, Post } from '@nestjs/common';
import { CategoriesOthersService } from '../services/categories-others.service';
import { CreateCategoriesOthers } from '../dto/create-categoriesOthers.dto';
import { CategoriesOthers } from '../schemas/categoriesOthers.schema';

@Controller('categories/categoriesOthers')
export class CategoriesOthersController {
  constructor(private readonly categoriesOthersService: CategoriesOthersService) {}

  @Post()
  public async create(@Body() createStructureDto: CreateCategoriesOthers) {
    await this.categoriesOthersService.create(createStructureDto);
  }

  @Get()
  public async findAll(): Promise<CategoriesOthers[]> {
    return this.categoriesOthersService.findAll();
  }
}
