import { Type } from 'class-transformer';
import { ArrayNotEmpty, IsNotEmpty, ValidateNested } from 'class-validator';
import { Address } from '../schemas/address.schema';
import { Week } from '../schemas/week.schema';

export class structureDto {
  numero: string;
  createdAt: string;
  updatedAt: string;
  deletedAt: Date;

  @IsNotEmpty()
  structureName: string;

  @IsNotEmpty()
  structureType: string;

  description: string;

  @ValidateNested({ each: true })
  @Type(() => Address)
  address: Address;

  @IsNotEmpty()
  contactPhone: string;

  @IsNotEmpty()
  contactMail: string;

  website: string;
  facebook: string;
  twitter: string;
  instagram: string;
  linkedin: string;

  lockdownActivity: string;
  otherDescription: string;
  @IsNotEmpty()
  pmrAccess: boolean;
  publicsAccompaniment: string[];
  proceduresAccompaniment: string[];
  @ArrayNotEmpty()
  accessModality: string[];

  labelsQualifications: string[];

  @ArrayNotEmpty()
  publics: string[];
  @IsNotEmpty()
  freeWorkShop: boolean;
  @IsNotEmpty()
  nbComputers: number;
  @IsNotEmpty()
  nbPrinters: number;
  @IsNotEmpty()
  nbTablets: number;
  @IsNotEmpty()
  nbNumericTerminal: number;
  @IsNotEmpty()
  nbScanners: number;
  exceptionalClosures: string;
  equipmentsAndServices: string[];
  hours: Week;
  baseSkills: string[];
  accessRight: string[];
  parentingHelp: string[];
  socialAndProfessional: string[];
  digitalCultureSecurity: string[];
  coord: number[];
  accountVerified: boolean;
}
