import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { Document, Types } from 'mongoose';

export type TempUserDocument = TempUser & Document;

@Schema({ timestamps: { createdAt: 'createdAt', updatedAt: 'updatedAt' } })
export class TempUser {
  @Prop({ required: true })
  email: string;

  @Prop({ default: null })
  pendingStructuresLink: Types.ObjectId[];
}

export const TempUserSchema = SchemaFactory.createForClass(TempUser);
