import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { Types } from 'mongoose';
import { UserRole } from '../enum/user-role.enum';
@Schema()
export class User {
  @Prop({ required: true })
  email: string;

  @Prop({ required: true })
  name: string;

  @Prop({ required: true })
  surname: string;

  @Prop({ required: true })
  phone: string;

  @Prop({ required: true })
  password: string;

  @Prop({ default: false })
  emailVerified: boolean;

  @Prop({ default: null })
  validationToken: string;

  @Prop({ default: null })
  resetPasswordToken: string;

  @Prop({ enum: [UserRole.admin, UserRole.user], default: UserRole.user })
  role: number;

  @Prop({ default: null })
  changeEmailToken: string;

  @Prop({ default: null })
  newEmail: string;

  @Prop({ default: null })
  structuresLink: Types.ObjectId[];

  @Prop({ default: null })
  pendingStructuresLink: Types.ObjectId[];

  @Prop({ default: null })
  structureOutdatedMailSent: Types.ObjectId[];
}

export const UserSchema = SchemaFactory.createForClass(User);
